// ===== Wolfgang Erben ========== Modellierung =====

package pruefung;

/**
 * Das Interface <b>Funktion</b> beschreibt reellwertige Funktionen
 * (eines reellen Parameters).
 * 
 * @author Wolfgang Erben
 * @version 3.3 1.4.2011
 */
public interface Funktion {
    int E = 3;
    
    /**
     * liefert den Wert der Funktion an der angegebenen Stelle.
     * An Stellen, wo die Funktion nicht definiert ist, kann - muss aber
     * nicht -  eine Exception geworfen werden.
     */
    double wertBei(double x);
    
    /**
     * prueft, ob die Funktion an der angegebenen Stelle definiert ist.
     */
    boolean istDefiniertBei(double x);
    
    /**
     * liefert irgend eine Stammfunktion.
     */
    Funktion stammFunktion();
}
