// ===== Modellierung ========== Wolfgang Erben

package pruefung;
/**
 * Die Klasse stellt Funktionalitaet fuer Funktionen bereit.
 * 
 * @author Wolfgang Erben
 * @version 1.0 06.04.2011
 */

public final class Funktionen {
    public static int[] E = { 2,7 }; 
    private Funktionen() {
    }
    
    /**
     * liefert die Riemann-Summe der angegebenen Funktion zwischen den
     * beiden angegebenen Grenzen bei aequidistanter Aufteilung in die
     * angegebene Anzahl von Intervallen. Als Zwischenstelle wird jeweils
     * der linke Rand genommen.
     */
    public static double riemannSummeVon(Funktion f, double von, double bis, 
            int anzahlIntervalle) {
        if (anzahlIntervalle <= 0) throw new IllegalArgumentException();
        double dx = (bis - von) / anzahlIntervalle;
        double summe = 0.;
        for (int i = 0; i < anzahlIntervalle; i++) {
            double x = von + i * dx;
            summe += f.wertBei(x) * dx;
        }
        return summe;
    }

}
