// ===== Wolfgang Erben ========== Modellierung =====
//
package pruefung;


/**
 * Die Klasse <b>MittelbareFunktion</b> beschreibt Hintereinander-Ausfuehrungen
 * von Funktionen.
 * 
 * @author Wolfgang Erben
 * @version 2.0 1.4.2011
 */
public final class MittelbareFunktion implements Funktion {
    private final Funktion mInnen;
    private final Funktion mAussen;
    
    /**
     * erzeugt die Funktion <b>f(x) = aussen(innen(x))</b>.
     */
    public MittelbareFunktion(Funktion aussen, Funktion innen) {
        mAussen = aussen;
        mInnen = innen;
    }
    
    /**
     * liefert den Wert der Funktion an der angegebenen Stelle.
     */
    public double wertBei(double x) {
		return mAussen.wertBei(mInnen.wertBei(x));
    }
    
    /**
     * prueft, ob die Funktion an der angegebenen Stelle definiert ist.
     */
    public boolean istDefiniertBei(double x) {
        if (!mInnen.istDefiniertBei(x)) return false;
        return mAussen.istDefiniertBei(mInnen.wertBei(x));
    }
    
    /**
     * liefert eine textuelle Darstellung der Funktion.
     */
    public String toString() {
        return "" + mAussen + "(" + mInnen + ")";
    }
    
    /**
     * die Funktion wird nicht unterstuetzt.
     */
    public Funktion stammFunktion() {
        throw new UnsupportedOperationException();
    }
    
}
