// ===== Wolfgang Erben ========== Modellierung =====

package pruefung;
import java.util.*;

public abstract class UeberallDefinierteFunktion implements Funktion {
    private static final int E = 1000;
    public UeberallDefinierteFunktion() {
    }
    public final boolean istDefiniertBei(double x) {
        return true;
    }
    public Funktion stammFunktion() {
        return new StammFunktion(this, 0.);
    }
    public double wertBei(double x) {
        return 0.;
    }
    public boolean equals(UeberallDefinierteFunktion f) {
        if (getClass() != f.getClass()) return false;
        if (wertBei(0.) != f.wertBei(0.)) return false;
        Random r = new Random();
        for (int i = 0; i < E; i++) {
            double x = r.nextDouble();
            if (wertBei(x) != f.wertBei(x)) return false;
        }
        return true;
    }
    public int hashCode() {
        Double d = new Double(wertBei(0.));
        return d.hashCode();
    }
}
