// ===== Modellierung ========== Wolfgang Erben

package pruefung.version2;
import java.util.*;
import pruefung.*;

public final class Polynom extends UeberallDefinierteFunktion {
    
    private List<Integer> mKoeff = new ArrayList<Integer>();
    public Polynom(int... koeff) {
        for (int a : koeff) mKoeff.add(a); 
    }
    public int grad() {
        return mKoeff.size() - 1; 
    }
    @Override
    public String toString() {
        return "Polynom" + mKoeff;
    }
    @Override
    public double wertBei(double x) {
        double erg = 0.;
        for (int a : mKoeff) erg = erg * x + a;
        return erg;
    }
    public int koeffizientVon(int n) {
        if (n >= mKoeff.size()) return 0;
        return mKoeff.get(mKoeff.size() - n - 1);
    }
    public Polynom plus(Polynom p) {
        int grad1 = Math.max(mKoeff.size(), p.mKoeff.size());
        int[] koeff = new int[grad1];
        for (int i = 0; i < grad1; i++)
            koeff[i] = koeffizientVon(i) + p.koeffizientVon(i);
        return new Polynom(koeff);
    }
    @Override
    public boolean equals(Object o) {
        if (o == this) return true;
        if (o == null) return false;
        if (getClass() != o.getClass()) return false;
        Polynom p = (Polynom) o;
        return p.mKoeff.equals(mKoeff);
    }
    private Polynom(List<Integer> koeff) {
        mKoeff = koeff;
    }
    @Override 
    public Polynom stammFunktion() {
        List<Integer> stKoeff = new ArrayList<Integer>();
        int anzahl = mKoeff.size();
        for (int i = 0; i < anzahl; i++) {
            int n = anzahl - i;
            stKoeff.add(mKoeff.get(i) / n);
        }
        stKoeff.add(0);
        return new Polynom(stKoeff);
    }
}
