// ===== Modellierung ========== Wolfgang Erben

package pruefung.version3;
import pruefung.*;

public class Polynom extends UeberallDefinierteFunktion {
    private final int[] mKoeff = new int[3];
    public Polynom(int a, int... koeff) {
        mKoeff[0] = a; 
        for (int i = 0; i < koeff.length; i++) mKoeff[i + 1] = koeff[i];
    }
    public Polynom(double a) {
        mKoeff[0] = (int) a;
    }
    public int grad() {
        return mKoeff.length - 1; 
    }
    @Override 
    public String toString() {
        return "Polynom" + mKoeff;
    }
    @Override
    public double wertBei(double x) {
        double erg = 0.;
        for (int a : mKoeff) erg = erg * x + a;
        return erg;
    }
}